BaseSecretKeyFactory (Bouncy Castle Library 1.52 API Specification)
Date: 2015-03-01

org.bouncycastle.jcajce.provider.symmetric.util

## Class BaseSecretKeyFactory

- java.lang.Object
- - javax.crypto.SecretKeyFactorySpi
  - - org.bouncycastle.jcajce.provider.symmetric.util.BaseSecretKeyFactory

- All Implemented Interfaces:
    PBE
  Direct Known Subclasses:
    DES.DESPBEKeyFactory, DES.KeyFactory, DESede.KeyFactory, PBEPBKDF2.BasePBKDF2, PBESecretKeyFactory, SHA1.BasePBKDF2WithHmacSHA1

      public class BaseSecretKeyFactory
      extends javax.crypto.SecretKeyFactorySpi
      implements PBE

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.bouncycastle.jcajce.provider.symmetric.util.PBE

      `PBE.Util`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.lang.String` | `algName`
    `protected ASN1ObjectIdentifier` | `algOid`

    - ### Fields inherited from interface org.bouncycastle.jcajce.provider.symmetric.util.PBE

      `GOST3411, MD2, MD5, OPENSSL, PKCS12, PKCS5S1, PKCS5S1_UTF8, PKCS5S2, PKCS5S2_UTF8, RIPEMD160, SHA1, SHA256, TIGER`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `BaseSecretKeyFactory(java.lang.String algName, ASN1ObjectIdentifier algOid)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected javax.crypto.SecretKey` | `engineGenerateSecret(java.security.spec.KeySpec keySpec)`
    `protected java.security.spec.KeySpec` | `engineGetKeySpec(javax.crypto.SecretKey key, java.lang.Class keySpec)`
    `protected javax.crypto.SecretKey` | `engineTranslateKey(javax.crypto.SecretKey key)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### algName

          protected java.lang.String algName

    - #### algOid

          protected ASN1ObjectIdentifier algOid

  - ### Constructor Detail

    - #### BaseSecretKeyFactory

          protected BaseSecretKeyFactory(java.lang.String algName,
                              ASN1ObjectIdentifier algOid)

  - ### Method Detail

    - #### engineGenerateSecret

          protected javax.crypto.SecretKey engineGenerateSecret(java.security.spec.KeySpec keySpec)
                                                         throws java.security.spec.InvalidKeySpecException

      Specified by:
        `engineGenerateSecret` in class `javax.crypto.SecretKeyFactorySpi`
      Throws:
        `java.security.spec.InvalidKeySpecException`

    - #### engineGetKeySpec

          protected java.security.spec.KeySpec engineGetKeySpec(javax.crypto.SecretKey key,
                                                    java.lang.Class keySpec)
                                                         throws java.security.spec.InvalidKeySpecException

      Specified by:
        `engineGetKeySpec` in class `javax.crypto.SecretKeyFactorySpi`
      Throws:
        `java.security.spec.InvalidKeySpecException`

    - #### engineTranslateKey

          protected javax.crypto.SecretKey engineTranslateKey(javax.crypto.SecretKey key)
                                                       throws java.security.InvalidKeyException

      Specified by:
        `engineTranslateKey` in class `javax.crypto.SecretKeyFactorySpi`
      Throws:
        `java.security.InvalidKeyException`